#ifndef WERTE_H
#define WERTE_H

#include <Arduino.h>
#include <Variablen.h>

class Werte : protected Variablen
{
    public:
        Werte(){};
        ~Werte(){};
        
        // Interaktion mit Timer: //
        static void set_ANL(int var);
        static int get_ANL();

        // Trigger Methode //
        static void check();

    private:
        static int _anl;

        static unsigned long int _new_time;
        static unsigned long int _nt_backup;
        static unsigned long int _old_time;
        static unsigned long int _delta;

        static double _in_stunden;
        static double _watt;

        static void nochimmer();
        static void calc();
};

#endif